#ifndef SEARCH_H_
#define SEARCH_H_

#include <vector>
#include <algorithm>
#include <cstdlib>
#include <stdlib.h>
#include <iostream>

#define SingleMaxCost_		100	// i1̍őRXg
#define SingleMaxValue_	100	// i1̍ő剿l
#define Limit_				400	// RXg
#define Trials_			100	// s
#define ArticlesNumber_	10	// Ii


// i
class Article {
protected:
	int cost;	// RXg
	int value;	// l
public:
	Article();
	Article(const int cost, const int value);
	int getValue(void){ return value; };
	void setValue(int v){ value = v; };
	int getCost(void){ return cost; };
	void setCost(int c){ cost = c; };
};

// iIXgiF̂Ȃǁj
class CandidateList {
protected:
	std::vector<bool> selectionList;	// iI邩ǂ̃Xg
	std::vector<Article>* goods;	// ۂ̕ĩXg
	int totalCost;	// ̑g̍vRXg
	int totalValue;	 // ̑g̍vl
	int selectionIndex;	// Xg̗vfɏԂɃANZX邽߂̃CfbNX
public:
	CandidateList();
	CandidateList& operator=(const CandidateList&);
	void randomSelect();
	int getSelectionNumber();
	Article* getTotals();
	int getTotalValue();
	int getTotalCost();
	void sysout();
	void invertArticleSelection(int n){	selectionList[n] = ! selectionList[n];	};
	void select( int n ){	selectionList[n] = true;	};
	void unselect( int n ){	selectionList[n] = false;	};
	void setSelection( int n, bool s ){	selectionList[n] = s;	};
	void startIndex(){	selectionIndex = 0;	};
	Article* nextArticle();
	bool isSelected(int n){	return selectionList[n];	};
	int similar( CandidateList& );
	std::vector<bool>* getSelectionList() {	return &selectionList;	};
private:
	void calculateTotals();
};

// 
class Condition {
protected:
	int singleMaxCost;	// i1̍őRXg
	int singleMaxValue;	// i1̍ő剿l
	int limit;	// RXg
	int trials;	// s
	int articlesNumber;	// Ii
	std::vector<Article> goods;	// Ώەi 
public:
	Condition();
	void setGoods();
	std::vector<Article>* getGoods(){	return &goods;	};
	void setTrials(int);
	int getTrials() {	return trials;	};
	void setLimit(int);
	int getLimit() {	return limit;	};
	int getArticlesNumber() {	return articlesNumber;	};
	void setArticlesNumber(int);
	int getSingleMaxCost() {	return singleMaxCost;	};
	void setSingleMaxCost(int);
	int getSingleMaxValue() {	return singleMaxValue;	};
	void setSingleMaxValue(int);
};

class Result {
protected:
	CandidateList bestCombination;	// = null;	// œKȕȋgݍ킹
	std::vector<Article> tryoutData;	// = null;	// sׂĂ̍vlƍvRXg
	std::vector<int> bestIndex;	// = null;	// ōʂꂽs񐔂̃Xg
	int tryoutDataIndex;	// = 0;	// sf[^opCfbNX
public:
	Result();
	void add( CandidateList& );
	int getBestCost() {	return bestCombination.getTotalCost();	};
	int getBestValue() {	return bestCombination.getTotalValue();	};
	std::vector<int>* getBestIndex() {	return &bestIndex;	};
	CandidateList* getBestCombination() {	return &bestCombination;	};
	std::vector<Article>* getTryoutData() {	return &tryoutData;	};
	void startTryoutData(){	tryoutDataIndex = 0;	};
	int getBestGoodsNumber(){	return bestCombination.getSelectionNumber();	};
	void bestOut();
};

class SearchMethod {
protected:
	int trials;	// s
	int limit;	// 
	int articlesNumber;	// i̐
	std::vector<Article>* goods;	// Ώەi
	Result result;	// S
public:
	SearchMethod();
	virtual ~SearchMethod() = 0;
	virtual void doSearch() = 0;
	void recordResult(CandidateList& list) {	result.add( list );	};
	Result getResult() {	return result;	};
};

class RandomSearch : public SearchMethod {
public:
	void doSearch();
};

class EvolutionaryMethod : public SearchMethod {
protected:
	int population;	// li1̌̐j
	CandidateList* parentGeneration;	// e
	CandidateList* childGeneration;	// q
public:
	EvolutionaryMethod();
	~EvolutionaryMethod();
	void doSearch();
	void setPopulation(int);
	int getPopulation() {	return population;	};
protected:
	virtual void newGeneration() = 0;
	void firstGeneration();
	void evaluateGeneration();
};

class GeneticAlgorithmMethod : public EvolutionaryMethod {
protected:
	double crossoverRatio;	// 
	float pm; // ˑRψق̊m
	void newGeneration();
	void crossover();
	void mutation();
public:
	GeneticAlgorithmMethod(){	crossoverRatio = 0.9;	};
	void doSearch();
	void setCrossoverRatio(double cr) {	crossoverRatio = cr;	};
};

// max ȉ̗Ԃ
int random(int);

// moddstrueԂ
bool probability(double);

extern Condition* condition;

#endif /*SEARCH_H_*/
